<?
/*

 $Id: create_cname.php,v 1.19 2003/10/23 22:05:26 vollmerk Exp $
 $Source: /a1/cvsroot/maint/docs/create_cname.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
/*!
	@header Create Cname
	The create-a-cname wizard mojo... we put the form here so the user can get instant feedback on the things
	that are foobed with the form.
*/

/* Start Housekeeping */
	require "../modules/config.php";
	
	// do anything that needs to be done here
	if (!check_session()) { logout(); }
		

	// setup the user environment
	setup_user_environment($action, $zone_id);

	$domains = $conf['zone']->domains();
/* End Housekeeping */

/*!
	@function create_cname
	@discussion  do what ever you have to do to create the cname if there's an error then we just re-display it
*/
if ($action == "create_cname") {

	// create the needed objects
	$cname = new Cname(0);


	// Check to see if they picked the admin domain select or not
	if ($user->is_admin AND $domain_select === 'admin') {
		$domain = new Domain($admin_domain_id);
		$domain_id = $admin_domain_id;
	} // end if admin & admin select
	else {
		$domain = new Domain($domain_id);
	} // end else 

	if ($top_cname) { 
		$data = split_hostname($domain->name);
		$name = $data->name;
		$domain_id = $domain->get_domain_by_name($data->domain);
		if (!$domain_id) { 
			$conf['error']->add_error('domain',"Unable to find sub-domain " . $data->domain);
		} // if now domain_id
		$domain = new Domain($domain_id);
	}

        // Make sure they have picked a ttl that is valid
        if (!is_numeric($ttl) || $ttl < 300) {
                $conf['error']->add_error('ttl',"Invalid TTL");
        }

	// double check the name and server
	$cname->check_name($name, $domain);
	$cname->check_server($server);

	if (!$conf['zone']->has_domain_access($domain_id) AND !$user->is_admin AND !$top_cname) { 
		$conf['error']->add_error('domain',$conf['zone']->name . " does not have access to $domain->name");
	}

	if (!$domain->name) {
		$conf['error']->add_error('domain',"Please Specifiy a Domain");
	}
	
	// if it looks good and they have access let's create it.
	if (!$conf['error']->error_state AND $user->has_access($conf['zone']->id)) 
	{
		$cname_id = $cname->new_item($server,$name,$domain->id,$conf['zone']->id,$ttl);
		$cname = new Cname($cname_id);
		$cname->object_history->update($user->username,$comment);
		// cname has been created.. let's shoot them off to viewing the cname		
		header("Location: " . $conf['web_path'] . "/cname.php?action=show_cname&action_type=read&cname_id=$cname_id");
		exit();
	}
}
show_template('header');


//requires the template for creating the cnames 
require ($conf['prefix'] . "/templates/show_create_cname.inc");



?>
